### ### ###
### example 1 ###

from vcScript import *
import sys
import socket

def NotOnSignal( signal ):
  global sock, network
  if signal == network:
    cols = []
    cols = network.Value.split(';',3)
    if cols[0] == getComponent().ExternalAddress:
      print "Send Camx data \"%s\" to outside" % network.Value
      sock.send(network.Value)
  
def OnStart():
  global sock, network
  comp = getComponent()
  HOST = comp.Server
  PORT = comp.Port
  sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
  sock.connect((HOST, PORT))
  sock.send('Robot \'%s\' connected' % comp.Name)
  network = getComponent().findBehaviour("Network")

def OnRun():
  global sock, network
  sock.setblocking(False)
  while True:
    try:
      data = ""
      data = sock.recv(4096)
      if data:
        print "Received Robot data from outside \"%s\"" % data
        network.signal(data)
    except:
      pass
    delay( 0.1 )


### ### ###
### example 2 ###

from vcScript import *
import sys
import socket

def OnStart():
  global sock
  HOST = '127.0.0.1'
  PORT = 5001
  sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
  sock.connect((HOST, PORT))
  sock.send('Simulation Started - opening connection')

def OnRun():
  global sock
  comp = getComponent()
  controller = comp.findBehaviour("Controller")
  sock.setblocking(False)
  data = ""
  while True:
    try:
      data = sock.recv(1024)
      cols = data.split(' ',2)
      joint = eval(cols[0])
      value = eval(cols[1])
      value -= 1100
      print "joint = %i value = %f" % (joint, value)
      controller.moveJoint(joint,value)
    except:
      pass
    delay( 0.1 )







